package com.jiuqi.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.StringUtils;

public class ParseDataSource {
  public static final int DATA_CONN_MSSQL2000 = 1;
  
  public static final int DATA_CONN_MSSQL2005 = 4;
  
  public static final int DATA_CONN_ORACLE = 2;
  
  public static final int DATA_CONN_DB2_LOCAL = 3;
  
  public static final int DATA_CONN_DB2_REMOTE = 5;
  
  public static final int DATA_CONN_MYSQL = 6;
  
  public static final int DATA_CONN_Other = 0;
  
  public static final String DATA_CONN_TITLE_MSSQL2000 = "SQL Server2000";
  
  public static final String DATA_CONN_TITLE_MSSQL2005 = "SQL SERVER2005";
  
  public static final String DATA_CONN_TITLE_ORACLE = "Oracle";
  
  public static final String DATA_CONN_TITLE_DB2_LOCAL = "Local DB2";
  
  public static final String DATA_CONN_TITLE_DB2_REMOTE = "Remote DB2";
  
  public static final String DATA_CONN_TITLE_MYSQL = "MySql";
  
  public static final String DATA_CONN_TITLE_Other = "其它";
  
  public static int getKind(String url) {
    int kind = 0;
    if (!StringUtils.isEmpty(url)) {
      String lowerUrl = url.toLowerCase();
      if (lowerUrl.indexOf("sqlserver") != -1) {
        if (lowerUrl.indexOf("microsoft") != -1) {
          kind = 1;
        } else {
          kind = 4;
        } 
      } else if (lowerUrl.indexOf("oracle") != -1) {
        kind = 2;
      } else if (lowerUrl.indexOf("db2") != -1) {
        if (lowerUrl.indexOf("//") != -1) {
          kind = 5;
        } else {
          kind = 3;
        } 
      } else if (lowerUrl.indexOf("mysql") != -1) {
        kind = 6;
      } 
    } 
    return kind;
  }
  
  public static String getServer(String url) {
    String server;
    int beginIndex, endIndex, kind = getKind(url);
    switch (kind) {
      case 1:
      case 4:
      case 5:
      case 6:
        beginIndex = url.indexOf("//") + 2;
        endIndex = url.indexOf(":", beginIndex);
        server = url.substring(beginIndex, endIndex);
        return server;
      case 3:
        return "localhost";
      case 2:
        beginIndex = url.indexOf("@") + 1;
        endIndex = url.indexOf(":", beginIndex);
        server = url.substring(beginIndex, endIndex);
        return server;
    } 
    return null;
  }
  
  public static String getPort(String url) {
    String port;
    int beginIndex, endIndex, kind = getKind(url);
    switch (kind) {
      case 1:
      case 4:
        beginIndex = url.lastIndexOf(":") + 1;
        endIndex = url.indexOf(";");
        port = url.substring(beginIndex, endIndex);
        return port;
      case 2:
        beginIndex = url.indexOf(":", url.indexOf("@")) + 1;
        endIndex = url.lastIndexOf(":");
        port = url.substring(beginIndex, endIndex);
        return port;
      case 3:
        return "50000";
      case 5:
      case 6:
        beginIndex = url.lastIndexOf(":") + 1;
        endIndex = url.lastIndexOf("/");
        port = url.substring(beginIndex, endIndex);
        return port;
    } 
    return null;
  }
  
  public static String getDBName(String url) {
    String dbName;
    int beginIndex, endIndex, kind = getKind(url);
    switch (kind) {
      case 1:
      case 4:
        beginIndex = url.indexOf("=") + 1;
        dbName = url.substring(beginIndex);
        return dbName;
      case 2:
      case 3:
        beginIndex = url.lastIndexOf(":") + 1;
        dbName = url.substring(beginIndex);
        return dbName;
      case 5:
        beginIndex = url.lastIndexOf("/") + 1;
        dbName = url.substring(beginIndex);
        return dbName;
      case 6:
        beginIndex = url.lastIndexOf("/") + 1;
        endIndex = url.indexOf("?");
        if (endIndex != -1 && endIndex > beginIndex)
          return url.substring(beginIndex, endIndex); 
        dbName = url.substring(beginIndex);
        return dbName;
    } 
    return null;
  }
  
  public static String getDriverClass(int kind) {
    String driverClass;
    switch (kind) {
      case 1:
        driverClass = "com.microsoft.jdbc.sqlserver.SQLServerDriver";
        return driverClass;
      case 4:
        driverClass = "com.microsoft.sqlserver.jdbc.SQLServerDriver";
        return driverClass;
      case 2:
        driverClass = "oracle.jdbc.driver.OracleDriver";
        return driverClass;
      case 3:
      case 5:
        driverClass = "COM.ibm.db2.jdbc.app.DB2Driver";
        return driverClass;
      case 6:
        driverClass = "com.mysql.jdbc.Driver";
        return driverClass;
    } 
    return null;
  }
  
  public static String buildUrl(int kind, String server, String port, String dbName) {
    StringBuffer urlStr = new StringBuffer();
    switch (kind) {
      case 1:
        urlStr.append("jdbc:microsoft:sqlserver://");
        urlStr.append(server);
        urlStr.append(":").append(port).append(";DatabaseName=").append(dbName);
        return urlStr.toString();
      case 4:
        urlStr.append("jdbc:sqlserver://");
        urlStr.append(server);
        urlStr.append(":").append(port).append(";DatabaseName=").append(dbName);
        return urlStr.toString();
      case 2:
        urlStr.append("jdbc:oracle:thin:@");
        urlStr.append(server);
        urlStr.append(":").append(port).append(":").append(dbName);
        return urlStr.toString();
      case 3:
        urlStr.append("jdbc:db2:" + dbName);
        return urlStr.toString();
      case 5:
        urlStr.append("jdbc:db2://");
        urlStr.append(server);
        urlStr.append(":").append(port).append("/").append(dbName);
        return urlStr.toString();
      case 6:
        urlStr.append("jdbc:mysql://");
        urlStr.append(server);
        urlStr.append(":").append(port).append("/").append(dbName);
        return urlStr.toString();
    } 
    return null;
  }
  
  public static String getConnTitle(int connKind) {
    switch (connKind) {
      case 1:
        return "SQL Server2000";
      case 4:
        return "SQL SERVER2005";
      case 2:
        return "Oracle";
      case 3:
        return "Local DB2";
      case 5:
        return "Remote DB2";
      case 6:
        return "MySql";
    } 
    return "其它";
  }
  
  public static String getDefaultPort(int kind) {
    switch (kind) {
      case 1:
        return "1433";
      case 4:
        return "1433";
      case 2:
        return "1521";
      case 3:
        return "50000";
      case 6:
        return "3306";
    } 
    return "";
  }
}
